unit utestproject;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, Forms, Controls, Graphics, Dialogs, DBGrids, StdCtrls,
  Buttons, ZConnection, ZDataset;

type

  { TfrmTest }

  TfrmTest = class(TForm)
    btApply: TBitBtn;
    dbgData: TDBGrid;
    dsData: TDataSource;
    edtSearch: TEdit;
    lbFilter: TLabel;
    qrPeopleFIRSTNAME: TStringField;
    qrPeopleLASTNAME: TStringField;
    qrPeoplePID: TLongintField;
    ZConnection1: TZConnection;
    qrPeople: TZReadOnlyQuery;
    procedure btApplyClick(Sender: TObject);
    procedure dbgDataTitleClick(Column: TColumn);
    procedure edtSearchChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
  private

  public

  end;

var
  frmTest: TfrmTest;
  lcFilter : string;

implementation

{$R *.frm}

{ TfrmTest }

procedure TfrmTest.btApplyClick(Sender: TObject);
begin
  dsData.DataSet.Filtered := true;
  dsData.DataSet.Refresh;

  if dsData.DataSet.FieldByName(lcFilter) is TStringField then
  begin
    dsData.DataSet.Filter := 'UPPER(' + lcFilter + ') like ' + quotedstr('%' + uppercase(edtSearch.Text) + '%');
  end
  else dsData.DataSet.Filter := lcFilter + ' = ' + edtSearch.Text;
  edtSearch.SelectAll;
  edtSearch.SetFocus;
end;

procedure TfrmTest.dbgDataTitleClick(Column: TColumn);
begin
  lbFilter.Caption := Column.Title.Caption;
  edtSearch.Clear;
  lcFilter := Column.FieldName;
  dsData.DataSet.Filtered := false;
  edtSearch.SetFocus;
end;

procedure TfrmTest.edtSearchChange(Sender: TObject);
begin
  if length(edtSearch.Text) = 0 then
  begin
    dsData.DataSet.Filtered := false;
    btApply.Enabled := false;
  end
  else btApply.Enabled := true;
end;

procedure TfrmTest.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  dsData.DataSet.Close;
end;

procedure TfrmTest.FormShow(Sender: TObject);
begin
  dsData.DataSet.Open;
  lbFilter.Caption := dbgData.Columns[0].Title.Caption;
  edtSearch.Clear;
  lcFilter := dbgData.Columns[0].FieldName;
  dsData.DataSet.Filtered := false;
end;

end.

